## org.gnu.gdk
Class Window

    java.lang.Object
      org.gnu.glib.Struct
          org.gnu.glib.GObject
              org.gnu.gdk.Drawable
                  org.gnu.gdk.Window

public class Window
extends Drawable

A rectangular region on the screen. It's a low-level object, used to implement high-level objects such as `Widget` and `Window` on the GTK+ level. A `Window` is a toplevel window, the thing a user might think of as a "window" with a titlebar and so on; a `Window` may contain many Windows.

Constructor Summary
`Window(org.gnu.glib.Handle handle)`
`Window(Window parent, WindowAttr attributes, int attributesMask)`

Method Summary
`void` `beginPaintRectangle(Rectangle rec)` Indicates that you are beginning the process of redrawing rec.
`void` `beginPaintRegion(Region region)` Indicates that you are beginning the process of redrawing region.
`void` `clear()` Clears an entire `window` to the background color or background pixmap.
`void` `clearArea(int x, int y, int width, int height, boolean exposeEvent)`
`void` `deiconify()` Asks to deiconify (ie unminimize) the specified window.
`void` `destroy()`
`void` `endPaint()` Indicates that the backing store created by the most recent call to beginPaintRegion() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region.
`Window[]` `getChildren()` Gets the list of children of window known to GDK.
`EventMask` `getEvents()` Gets the event mask for window.
`Rectangle` `getFrameExtents()` Obtains the bounding box of the window, including window manager titlebar/borders if any.
`int` `getHeight()` Retrieve the current height of the Window.
`void` `getKeyboardFocus()`
`Point` `getOrigin()` Obtains the position of a window in root window coordinates.
`Window` `getParent()` Obtains the parent of window, as known to GDK.
`Point` `getPosition()` Obtains the position of the window as reported in the most-recently-processed EventConfigure.
`Point` `getRootOrigin()` Obtains the top-left corner of the window manager frame in root window coordinates.
`Window` `getToplevel()` Gets the toplevel window that's an ancestor of this window.
`static Window[]` `getTopLevelWindows()`
`static Type` `getType()` Retrieve the runtime type used by the GLib library.
`int` `getWidth()` Retrieve the current width of the Window.
`Window` `getWindowAt(int x, int y)` Deprecated. This method is incorrect and is deprecated in favor of `getWindowAtPointer()`.
`Window` `getWindowAtPointer()` Obtains the window underneath the mouse pointer.
`static Window` `getWindowFromHandle(org.gnu.glib.Handle hndl)` Only to be used internally by Java-Gnome.
`WindowState` `getWindowState()`
`GrabStatus` `grabKeyboard(boolean ownerEvents, int time)` Grabs the keyboard so that all events are passed to this application until the keyboard is ungrabbed with ungrabKeyboard.
`GrabStatus` `grabPointer(boolean ownerEvents, EventMask eventMask, Window confineTo, Cursor cursor, int time)` Grabs the pointer (usually a mouse) so that all events are passed to this application until the pointer is ungrabbed with ungrabPointer, or the grab window becomes unviewable.
`void` `hide()` For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.
`void` `iconify()` Asks to iconify (ie minimize) the specified window.
`boolean` `isViewable()`
`boolean` `isVisible()`
`void` `lower()`
`void` `maximize()` Asks to maximize window, so that it becomes full-screen.
`void` `mergeChildShapes()`
`void` `move(int x, int y)` Repositions a window relative to its parent window.
`void` `moveAndResize(int x, int y, int width, int height)` Equivalent to calling `move()` and `resize()`, except that both operations are performed at once, avoiding strange visual effects (ie the user may be able to see the window first move, then resize, if you don't use `moveAndResize()`).
`boolean` `pointerIsGrabbed()` Returns true if the pointer is currently grabbed by this application.
`void` `raise()`
`void` `reparent(Window parent, int x, int y)` Reparents window into the given `parent`.
`void` `resize(int width, int height)` Resizes window; for toplevel windows, asks the window manager to resize the window.
`void` `scrollContent(int x, int y)`
`void` `setBackground(Color color)` Sets the background color of a window.
`void` `setBackground(Pixmap pixmap, boolean parentRelative)` Sets the background pixmap of window.
`void` `setBitmapMask(Bitmap mask, int x, int y)`
`void` `setChildMask(boolean masked)`
`void` `setCursor(Cursor cursor)` Sets the mouse pointer for a Window.
`void` `setEvents(EventMask mask)` The event mask for a window determines which events will be reported for that window.
`void` `setGeometryHints(Geometry geometry, WindowHints hints)` Sets the geometry hints for a window.
`void` `setHint(WindowTypeHint hint)`
`void` `setIcon(Window icon, Pixmap pixmap, Bitmap mask)` Sets up the icon representing a Window.
`void` `setIconList(Pixbuf[] icons)` Sets up the icon representing a Window.
`void` `setIconName(java.lang.String name)` Sets the icon for the window from a named themed icon.
`void` `setModalHint(boolean modal)` The application can use this hint to tell the window manager that a certain window has modal behavior.
`void` `setRegionMask(Region region, int x, int y)`
`void` `setRole(java.lang.String role)` The window manager and session manager use a window's role to distinguish it from other kinds of window in the same application.
`boolean` `setStaticGravities(boolean useStatic)` Set the bit gravity of the given window to static, and flag it so all children get static subwindow gravity.
`void` `setTitle(java.lang.String title)` Sets the title of a toplevel window, to be displayed in the titlebar.
`void` `setTransientOf(Window parent)` Indicates to the window manager that the window is a transient dialog associated with the application window parent.
`void` `setUnmanaged(boolean unmanaged)`
`void` `show()` Raises the `window` to the top of the window stack (moves the window to the front of the Z-order).
`void` `showUnraised()` Shows a `GdkWindow` onscreen, but does not modify its stacking order.
`void` `stick()` Asks to stick window, which means that it will appear on all user desktops.
`void` `ungrabKeyboard(int time)` Ungrabs the keyboard, if it is grabbed by this application.
`void` `ungrabPointer(int time)` Ungrabs the pointer, if it is grabbed by this application.
`void` `unmaximize()` Asks to unmaximize window.
`void` `unstick()` Asks to unstick window, which means that it will appear on only one of the user's desktops.
`void` `withdraw()` Withdraws a window (unmaps it and asks the window manager to forget about it).

Methods inherited from class org.gnu.gdk.Drawable

`drawArc, drawArc, drawDrawable, drawDrawable, drawGlyphs, drawGlyphs, drawGrayImage, drawGrayImage, drawImage, drawImage, drawIndexedImage, drawIndexedImage, drawLayout, drawLayout, drawLayoutLine, drawLayoutLine, drawLayoutLineWithColors, drawLayoutLineWithColors, drawLayoutWithColors, drawLayoutWithColors, drawLine, drawLine, drawLines, drawLines, drawPixbuf, drawPixbuf, drawPoint, drawPoint, drawPoints, drawPoints, drawPolygon, drawPolygon, drawRectangle, drawRectangle, drawRGB32Image, drawRGB32Image, drawRGB32ImageDitherAlign, drawRGB32ImageDitherAlign, drawRGBImage, drawRGBImage, drawRGBImageDitherAlign, drawRGBImageDitherAlign, drawSegments, drawSegments, getClipRegion, getColormap, getDepth, getDisplay, getImage, getScreen, getSize, getVisibleRegion, getVisual, setColormap`

Methods inherited from class org.gnu.glib.GObject

`addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addListener, collect, freezeNotify, getBooleanProperty, getData, getDoubleProperty, getEventListenerClass, getEventType, getFloatProperty, getGObjectFromHandle, getIntProperty, getJavaObjectProperty, getLongProperty, getPixbufProperty, getProperty, getStringProperty, hasProperty, notify, removeEventHandler, removeListener, setBooleanProperty, setData, setDoubleProperty, setFloatProperty, setIntProperty, setJavaObjectProperty, setLongProperty, setPixbufProperty, setProperty, setStringProperty, thawNotify`

Methods inherited from class org.gnu.glib.Struct
`equals, getHandle, getNullHandle, hashCode`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Window

    public Window(org.gnu.glib.Handle handle)

### Window

    public Window(Window parent,
                  WindowAttr attributes,
                  int attributesMask)

Method Detail

### destroy

    public void destroy()

### getWindowAt

    public Window getWindowAt(int x,
                              int y)

  Deprecated. This method is incorrect and is deprecated in favor of `getWindowAtPointer()`.

  Obtains the window underneath the mouse pointer. Returs NULL if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

  Parameters:
    `x` - X position of the window.
    `y` - Y position of the window.
  Returns:
    The window underneath the mouse pointer.

### getWindowAtPointer

    public Window getWindowAtPointer()

  Obtains the window underneath the mouse pointer. Returs NULL if the window under the mouse pointer is not known to GDK (for example, belongs to another application).

  Returns:
    The window underneath the mouse pointer.

### show

    public void show()

  Raises the `window` to the top of the window stack (moves the window to the front of the Z-order).

### hide

    public void hide()

  For toplevel windows, withdraws them, so they will no longer be known to the window manager; for all windows, unmaps them, so they won't be displayed.

### withdraw

    public void withdraw()

  Withdraws a window (unmaps it and asks the window manager to forget about it).

### showUnraised

    public void showUnraised()

  Shows a `GdkWindow` onscreen, but does not modify its stacking order. In contrast, `show()` will raise the window to the top of the window stack.

### move

    public void move(int x,
                     int y)

  Repositions a window relative to its parent window. For toplevel windows, window managers may ignore or modify the move; For child windows, the move will reliably succeed.

  Parameters:
    `x` - new x position.
    `y` - new y position.

### resize

    public void resize(int width,
                       int height)

  Resizes window; for toplevel windows, asks the window manager to resize the window. The window manager may not allow the resize. Windows may not be resized below 1x1.

  Parameters:
    `width` - the new window width.
    `height` - the new window height.

### moveAndResize

    public void moveAndResize(int x,
                              int y,
                              int width,
                              int height)

  Equivalent to calling `move()` and `resize()`, except that both operations are performed at once, avoiding strange visual effects (ie the user may be able to see the window first move, then resize, if you don't use `moveAndResize()`).

  Parameters:
    `x` - the new x position.
    `y` - the new y position.
    `width` - the new width.
    `height` - the new height.

### reparent

    public void reparent(Window parent,
                         int x,
                         int y)

  Reparents window into the given `parent`. The window being reparented will be unmapped as a side effect.

  Parameters:
    `parent` - the new parent to move window into.
    `x` - X location inside the new parent.
    `y` - Y location inside the new parent.

### clear

    public void clear()

  Clears an entire `window` to the background color or background pixmap.

### clearArea

    public void clearArea(int x,
                          int y,
                          int width,
                          int height,
                          boolean exposeEvent)

### raise

    public void raise()

### lower

    public void lower()

### getKeyboardFocus

    public void getKeyboardFocus()

### setUnmanaged

    public void setUnmanaged(boolean unmanaged)

### scrollContent

    public void scrollContent(int x,
                              int y)

### setBitmapMask

    public void setBitmapMask(Bitmap mask,
                              int x,
                              int y)

### setRegionMask

    public void setRegionMask(Region region,
                              int x,
                              int y)

### setChildMask

    public void setChildMask(boolean masked)

### mergeChildShapes

    public void mergeChildShapes()

### isVisible

    public boolean isVisible()

### isViewable

    public boolean isViewable()

### getWindowState

    public WindowState getWindowState()

### setHint

    public void setHint(WindowTypeHint hint)

### getTopLevelWindows

    public static Window[] getTopLevelWindows()

### getWidth

    public int getWidth()

  Retrieve the current width of the Window.

  Overrides:
    `getWidth` in class `Drawable`
  Returns:
    The width of the Window.

### getHeight

    public int getHeight()

  Retrieve the current height of the Window.

  Overrides:
    `getHeight` in class `Drawable`
  Returns:
    The height of the Window.

### setEvents

    public void setEvents(EventMask mask)

  The event mask for a window determines which events will be reported for that window. For example, an event mask including BUTTON_PRESS_MASK means the window should report button press events. The event mask is the bitwise OR of values from the EventMask enumeration.

  Parameters:
    `mask` - the new event mask.

### getEvents

    public EventMask getEvents()

  Gets the event mask for window.

  Returns:
    the event mask of the window.
  See Also:
    `setEvents(EventMask)`

### setStaticGravities

    public boolean setStaticGravities(boolean useStatic)

  Set the bit gravity of the given window to static, and flag it so all children get static subwindow gravity. This is used if you are implementing scary features that involve deep knowledge of the windowing system. Don't worry about it unless you have to.

  Parameters:
    `useStatic` -
  Returns:
    true if the server supports static gravity.

### setModalHint

    public void setModalHint(boolean modal)

  The application can use this hint to tell the window manager that a certain window has modal behavior. The window manager can use this information to handle modal windows in certain ways.

  Parameters:
    `modal` -

### setGeometryHints

    public void setGeometryHints(Geometry geometry,
                                 WindowHints hints)

  Sets the geometry hints for a window.

  Parameters:
    `geometry` -
    `hints` -

### beginPaintRectangle

    public void beginPaintRectangle(Rectangle rec)

  Indicates that you are beginning the process of redrawing rec. A backing store (offscreen buffer) large enough to contain rectangle will be created. The backing store will be initialized with the background color or background pixmap for window. Then, all drawing operations performed on window will be diverted to the backing store. When you call endPaint(), the backing store will be copied to window, making it visible onscreen. Only the part of window contained in region will be modified; that is, drawing operations are clipped to rectangle.

  Parameters:
    `rec` -

### beginPaintRegion

    public void beginPaintRegion(Region region)

  Indicates that you are beginning the process of redrawing region. A backing store (offscreen buffer) large enough to contain region will be created. The backing store will be initialized with the background color or background pixmap for window. Then, all drawing operations performed on window will be diverted to the backing store. When you call endPaint(), the backing store will be copied to window, making it visible onscreen. Only the part of window contained in region will be modified; that is, drawing operations are clipped to region.

  Parameters:
    `region` -

### endPaint

    public void endPaint()

  Indicates that the backing store created by the most recent call to beginPaintRegion() should be copied onscreen and deleted, leaving the next-most-recent backing store or no backing store at all as the active paint region. See beginPaintRegion() for full details. It is an error to call this function without a matching beginPaintRegion() first.

### setTitle

    public void setTitle(java.lang.String title)

  Sets the title of a toplevel window, to be displayed in the titlebar. If you haven't explicitly set the icon name for the window (using setIconName()), the icon name will be set to title as well. Title may not be null.

  Parameters:
    `title` -

### setRole

    public void setRole(java.lang.String role)

  The window manager and session manager use a window's role to distinguish it from other kinds of window in the same application. When an application is restarted after being saved in a previous session, all windows with the same title and role are treated as interchangeable. So if you have two windows with the same title that should be distinguished for session management purposes, you should set the role on those windows. It doesn't matter what string you use for the role, as long as you have a different role for each non-interchangeable kind of window

  Parameters:
    `role` -

### setTransientOf

    public void setTransientOf(Window parent)

  Indicates to the window manager that the window is a transient dialog associated with the application window parent. This allows the window manager to do things like center window on parent and keep window above parent.

  Parameters:
    `parent` -

### setBackground

    public void setBackground(Color color)

  Sets the background color of a window.

  Parameters:
    `color` -

### setBackground

    public void setBackground(Pixmap pixmap,
                              boolean parentRelative)

  Sets the background pixmap of window. May also be used to set a background of "None" on window, by setting a background pixmap of null. A background pixmap will be tiled, positioning the first tile at the origin of window, or if parent_relative is true, the tiling will be done based on the origin of the parent window (useful to align tiles in a parent with tiles in a child).

  Parameters:
    `pixmap` -
    `parentRelative` -

### setCursor

    public void setCursor(Cursor cursor)

  Sets the mouse pointer for a Window.

  Parameters:
    `cursor` -

### getPosition

    public Point getPosition()

  Obtains the position of the window as reported in the most-recently-processed EventConfigure. Contrast with getGeometry() which queries the X server for the current window position, regardless of which events have been received or processed.

### getOrigin

    public Point getOrigin()

  Obtains the position of a window in root window coordinates. (Compare with getPosition() and getGeometry() which return the position of a window relative to its parent window.)

### getRootOrigin

    public Point getRootOrigin()

  Obtains the top-left corner of the window manager frame in root window coordinates.

### getFrameExtents

    public Rectangle getFrameExtents()

  Obtains the bounding box of the window, including window manager titlebar/borders if any. The frame position is given in root window coordinates. To get the position of the window itself (rather than the frame) in root window coordinates, use getOrigin().

### getParent

    public Window getParent()

  Obtains the parent of window, as known to GDK. Does not query the X server; thus this returns the parent as passed to the constructor, not the actual parent.

### getToplevel

    public Window getToplevel()

  Gets the toplevel window that's an ancestor of this window.

### getChildren

    public Window[] getChildren()

  Gets the list of children of window known to GDK. This function only returns children created via GDK, so for example it's useless when used with the root window; it only returns windows an application created itself.

### setIconList

    public void setIconList(Pixbuf[] icons)

  Sets up the icon representing a Window. The icon is used when the window is minimized (also known as iconified). Some window managers or desktop environments may also place it in the window frame, or display it in other contexts.

  This method allows you to pass in the same icon in several hand-drawn sizes. The list should contain the natural sizes your icon is available in; that is, don't scale the image before passing it. Scaling is postponed until the last minute, when the desired final size is known, to allow best quality.

  By passing several sizes, you may improve the final image quality of the icon, by reducing or eliminating automatic image scaling.

  Recommended sizes to provide: 16x16, 32x32, 48x48 at minimum, and larger images (64x64, 128x128) if you have them.

  Parameters:
    `icons` -

### setIcon

    public void setIcon(Window icon,
                        Pixmap pixmap,
                        Bitmap mask)

  Sets up the icon representing a Window. This icon is used when the window is minimized (also known as iconified). Some window managers or desktop environments may also place it in the window frame, or display it in other contexts.

  The icon should be provided in whatever size it was naturally drawn; that is, don't scale the image before passing it. Scaling is postponed until the last minute, when the desired final size is known, to allow best quality.

  If you have your icon hand-drawn in multiple sizes, use setIconList(). Then the best size will be used.

  Parameters:
    `icon` -
    `pixmap` -
    `mask` -

### setIconName

    public void setIconName(java.lang.String name)

  Sets the icon for the window from a named themed icon. See the docs for `IconTheme` for more details.

  Parameters:
    `name` -

### iconify

    public void iconify()

  Asks to iconify (ie minimize) the specified window. Note that you shouldn't assume the window is definitely iconified afterward, because other entities (e.g. the user or window manager) could deiconify it again, or there may not be a window manager in which case iconification isn't possible, etc. But normally the window will end up iconified. Just don't write code that crashes if not.

### deiconify

    public void deiconify()

  Asks to deiconify (ie unminimize) the specified window. Note that you shouldn't assume the window is definitely deiconified afterward, because other entities (e.g. the user or window manager) could iconify it again before your code which assumes deiconification gets to run.

### stick

    public void stick()

  Asks to stick window, which means that it will appear on all user desktops. Note that you shouldn't assume the window is definitely stuck afterward, because other entities (e.g. the user or window manager) could unstick it again, and some window managers do not support sticking windows. But normally the window will end up stuck. Just don't write code that crashes if not.

### unstick

    public void unstick()

  Asks to unstick window, which means that it will appear on only one of the user's desktops. Note that you shouldn't assume the window is definitely unstuck afterward, because other entities (e.g. the user or window manager) could stick it again. But normally the window will end up unstuck. Just don't write code that crashes if not.

### maximize

    public void maximize()

  Asks to maximize window, so that it becomes full-screen.

### unmaximize

    public void unmaximize()

  Asks to unmaximize window.

### grabPointer

    public GrabStatus grabPointer(boolean ownerEvents,
                                  EventMask eventMask,
                                  Window confineTo,
                                  Cursor cursor,
                                  int time)

  Grabs the pointer (usually a mouse) so that all events are passed to this application until the pointer is ungrabbed with ungrabPointer, or the grab window becomes unviewable. This overrides any previous pointer grab by this client.

  Pointer grabs are used for operations which need complete control over mouse events, even if the mouse leaves the application. For example in GTK+ it is used for Drag and Drop, for dragging the handle in the HPaned and VPaned widgets, and for resizing columns in CList widgets.

  Note that if the event mask of an X window has selected both button press and button release events, then a button press event will cause an automatic pointer grab until the button is released. X does this automatically since most applications expect to receive button press and release events in pairs. It is equivalent to a pointer grab on the window with ownerEvents set to true.

  Parameters:
    `ownerEvents` - if false then all pointer events are reported with respect to window and are only reported if selected by event_mask. If true then pointer events for this application are reported as normal, but pointer events outside this application are reported with respect to window and only if selected by event_mask. In either mode, unreported events are discarded.
    `eventMask` - specifies the event mask, which is used in accordance with ownerEvents. Note that only pointer events (i.e. button and motion events) may be selected.
    `confineTo` - If non-null, the pointer will be confined to this window during the grab. If the pointer is outside confineTo, it will automatically be moved to the closest edge of confineTo and enter and leave events will be generated as necessary.
    `cursor` - the cursor to display while the grab is active. If this is null then the normal cursors are used for window and its descendants, and the cursor for window is used for all other windows.
    `time` - the timestamp of the event which led to this pointer grab. This usually comes from a EventButton, though CURRENT_TIME can be used if the time isn't known.

### ungrabPointer

    public void ungrabPointer(int time)

  Ungrabs the pointer, if it is grabbed by this application.

  Parameters:
    `time` -

### pointerIsGrabbed

    public boolean pointerIsGrabbed()

  Returns true if the pointer is currently grabbed by this application.

### grabKeyboard

    public GrabStatus grabKeyboard(boolean ownerEvents,
                                   int time)

  Grabs the keyboard so that all events are passed to this application until the keyboard is ungrabbed with ungrabKeyboard. This overrides any previous keyboard grab by this client.

  Parameters:
    `ownerEvents` - if false then all keyboard events are reported with respect to window. If true then keyboard events for this application are reported as normal, but keyboard events outside this application are reported with respect to window. Both key press and key release events are always reported, independant of the event mask set by the application.
    `time` -

### ungrabKeyboard

    public void ungrabKeyboard(int time)

  Ungrabs the keyboard, if it is grabbed by this application.

  Parameters:
    `time` -

### getType

    public static Type getType()

  Retrieve the runtime type used by the GLib library.

### getWindowFromHandle

    public static Window getWindowFromHandle(org.gnu.glib.Handle hndl)

  Only to be used internally by Java-Gnome.